unit Generate;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Generator, Calculator;

type
  TGenerateForm = class(TForm)
    GenEdit: TEdit;
    GenBtn: TButton;
    TimeEdit: TEdit;
    Label1: TLabel;
    CloseBtn: TButton;
    procedure GenBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GenerateForm: TGenerateForm;

procedure Signal1;

implementation

var
 Temp:Array of Single;
{$R *.dfm}

procedure Signal1;
var
 FString:String;
 MathRec:TMathRecord;
 ErrorCode,ErrorOk:Integer;
 k:DWord;
 t,dt:Single;
 Time:Single;
 Res:Single;
begin
 t:=0; dt:=WAV.DeltaTime;
 Val(GenerateForm.TimeEdit.Text,Time,ErrorCode);
 if ErrorCode<>0 then
  ErrorOk:=Application.MessageBox('Error in time format','Error !!!',0);
 WAV.Size:=Round(Time/WAV.DeltaTime) + 1000;
 SetLength(Temp,WAV.Size + 1000);
 FString:=' ' + GenerateForm.GenEdit.Text + ' ';
 ToRpn(FString,MathRec,ErrorCode);
 if ErrorCode<>0 then
  ErrorOk:=Application.MessageBox('Error in expression','Error !!!',0);
 for k:=0 to WAV.Size do
 begin
  IntTime:=t;
  EvaluateRpn(MathRec,ErrorCode,Res);
  if ErrorCode<>0 then
  begin
   ErrorOk:=Application.MessageBox('Error while generating the signal','Error !!!',0);
   Exit
  end;
  Temp[k]:=Res;
  t:=t + dt;
  if (k mod 1000)=0 then
   Progress(k/WAV.Size);
 end;
 for k:=0 to WAV.Size do
  WAV.AudioDataR[k]:=Temp[k];
 SetLength(Temp,0);
 WAV.SetMaxLevel(30000);
 GenerateForm.GenEdit.Text:=WriteRpn(MathRec);
end;


procedure TGenerateForm.GenBtnClick(Sender: TObject);
begin
 Signal1;
 Info;
 grMode:=2;
 EnableScaling;
 ShowWave(oscTime,oscTime + oscDeltaTime);
 WAV.SaveWaveFile('Data.wav');
 ClearProgress;
 Txt('Data.wav saved');
 Info;
 GenerateForm.Visible:=False;
end;

procedure TGenerateForm.CloseBtnClick(Sender: TObject);
begin
 GenerateForm.Visible:=False;
end;

end.
